<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN"><HTML><HEAD><TITLE>80386 Programmer's Reference Manual -- Opcode CBW</TITLE> </HEAD><BODY><B>up:</B> <A HREF="c17.htm">Chapter 17 -- 80386 Instruction Set</A><BR><B>prev:</B><A HREF="CALL.htm"> CALL Call Procedure</A><BR><B>next:</B><A HREF="CLC.htm"> CLC Clear Carry Flag</A><P><HR><P><H1>CBW/CWDE -- Convert Byte to Word/Convert Word to Doubleword</H1><PRE>
Opcode    Instruction     Clocks          Description

98        CBW             3               AX := sign-extend of AL
98        CWDE            3               EAX := sign-extend of AX
</PRE><H2>Operation</H2><PRE>
IF OperandSize = 16 (* instruction = CBW *)
THEN AX := SignExtend(AL);
ELSE (* OperandSize = 32, instruction = CWDE *)
   EAX := SignExtend(AX);
FI;
</PRE><H2>Description</H2>CBW converts the signed byte in AL to a signed word in AX by extending the most significant bit of AL (the sign bit) into all of the bits of AH. CWDE converts the signed word in AX to a doubleword in EAX by extending the most significant bit of AX into the two most significant bytes of EAX. Note that CWDE is different from CWD. CWD uses DX:AX rather than EAX as a destination.<H2>Flags Affected</H2>None<H2>Protected Mode Exceptions</H2>None<H2>Real Address Mode Exceptions</H2>None<H2>Virtual 8086 Mode Exceptions</H2>None<P><HR><P><B>up:</B> <A HREF="c17.htm">Chapter 17 -- 80386 Instruction Set</A><BR><B>prev:</B><A HREF="CALL.htm"> CALL Call Procedure</A><BR><B>next:</B><A HREF="CLC.htm"> CLC Clear Carry Flag</A> </BODY>